summaryrefslogtreecommitdiff
path: root/tests/qemu-iotests/035
diff options
context:
space:
mode:
authorKevin Wolf <kwolf@redhat.com>2012-04-24 16:30:23 +0200
committerKevin Wolf <kwolf@redhat.com>2012-05-02 18:39:39 +0200
commitdad5e5768e06ac7a22d0e7541ca8c6b6c42015a0 (patch)
treeddb64f27af1424315d174e54a9c301f1a244aebc /tests/qemu-iotests/035
parentbf3f363a5b52e6f246bcab74dafffa61d6e4d2a7 (diff)
downloadqemu-dad5e5768e06ac7a22d0e7541ca8c6b6c42015a0.tar.gz
qemu-iotests: Many parallel allocating I/O requests
This test case manages to let qcow2 abort because its cache is used up and it can't find free cache entries for new requests any more. Signed-off-by: Kevin Wolf <kwolf@redhat.com>
Diffstat (limited to 'tests/qemu-iotests/035')
-rwxr-xr-xtests/qemu-iotests/03572
1 files changed, 72 insertions, 0 deletions
diff --git a/tests/qemu-iotests/035 b/tests/qemu-iotests/035
new file mode 100755
index 0000000000..56616a1b7d
--- /dev/null
+++ b/tests/qemu-iotests/035
@@ -0,0 +1,72 @@
+#!/bin/bash
+#
+# Let a few AIO requests run in parallel and have them access different L2
+# tables so that the cache has a chance to get used up.
+#
+# Copyright (C) 2012 Red Hat, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+#
+
+# creator
+owner=kwolf@redhat.com
+
+seq=`basename $0`
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+
+_cleanup()
+{
+ _cleanup_test_img
+}
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+# get standard environment, filters and checks
+. ./common.rc
+. ./common.filter
+
+_supported_fmt generic
+_supported_proto generic
+_supported_os Linux
+
+
+size=6G
+CLUSTER_SIZE=512
+
+echo
+echo "creating image"
+_make_test_img $size
+
+function generate_requests() {
+ for i in $(seq 0 63); do
+ echo "aio_write ${i}M 512"
+ echo "aio_write ${i}M 512"
+ echo "aio_write ${i}M 512"
+ done
+}
+
+generate_requests | $QEMU_IO $TEST_IMG | _filter_qemu_io |\
+ sed -e 's/bytes at offset [0-9]*/bytes at offset XXX/g'
+
+echo
+echo "checking image for errors"
+_check_test_img
+
+# success, all done
+echo "*** done"
+rm -f $seq.full
+status=0